<?php
/*
  $Id: fixed.php,v 1.18 2007/10/10 23:41:17 auctionblox Exp $

  AuctionBlox, sell more, work less!
  http://www.auctionblox.com

  Copyright (c) 2004-2005 AuctionBlox
*/

  class_exists('abxCart') || require_once(realpath(dirname(__FILE__). '/../auctionblox/includes/classes/abxCart.php'));

  class fixed {
    var $code, $title, $description, $icon, $enabled, $methodTitles, $errors = array();
    
    var $OTHER_SHIPPING = 'Other enabled shipping modules';
    var $FIXED_SHIPPING_TABLE = 'Fixed shipping table';
    var $FIXED_SHIPPING_SPECIFIED = 'Shipping specified in listing';

// class constructor
    function fixed() {

      $this->code = 'fixed';
      $this->title = MODULE_SHIPPING_FIXED_TEXT_TITLE;
      $this->description = MODULE_SHIPPING_FIXED_TEXT_DESCRIPTION;
      $this->sort_order = MODULE_SHIPPING_FIXED_SORT_ORDER;
      $this->icon = '';
      $this->tax_class = MODULE_SHIPPING_FIXED_TAX_CLASS;
      $this->enabled = $this->is_enabled();
      
      $this->methodTitles = array(
            'uninsured'         => MODULE_SHIPPING_FIXED_STANDARD_METHOD,
            'uninsuredupgrade1' => MODULE_SHIPPING_FIXED_UPGRADE1_METHOD,
            'uninsuredupgrade2' => MODULE_SHIPPING_FIXED_UPGRADE2_METHOD,
            'uninsuredupgrade3' => MODULE_SHIPPING_FIXED_UPGRADE3_METHOD,
            'insured'           => MODULE_SHIPPING_FIXED_STANDARD_INSURED_METHOD,
            'insuredupgrade1'   => MODULE_SHIPPING_FIXED_UPGRADE1_INSURED_METHOD,
            'insuredupgrade2'   => MODULE_SHIPPING_FIXED_UPGRADE2_INSURED_METHOD,
            'insuredupgrade3'   => MODULE_SHIPPING_FIXED_UPGRADE3_INSURED_METHOD
      );
    }

// class methods

  function quote($method = '')
  {
    global $order;

    $module = null;
    $quotes = null;

    if($order->delivery['country_id'] === STORE_COUNTRY)
      $module = MODULE_SHIPPING_FIXED_DOMESTIC_TITLE;
    else
      $module = MODULE_SHIPPING_FIXED_GLOBAL_TITLE;

    $shipping = $this->calculateShipping();
    $insurance = $this->calculateInsurance();

    if($shipping < 0 || sizeof($this->errors) > 0)
    {
    	$error = MODULE_SHIPPING_FIXED_SHIPPING_NOT_SET_ERROR;
    	foreach($this->errors as $key => $value)
    	{
    	  $error .= '<br/>' . $value;
    	}
    	
        $quotes = array('id' 	=> $this->code,
                  'module' 		=> $module,
                  'error' 		=> $error);
      
        tep_mail(STORE_OWNER, 
                 STORE_OWNER_EMAIL_ADDRESS, 
                 MODULE_SHIPPING_FIXED_SHIPPING_EMAIL_SUBJECT, 
                 $error, 
                 $order->customer['firstname'] . " " . $order->customer['lastname'], 
                 $order->customer['email_address']);
    }
    else if($method !== '') // method selection
    {
        // build a list of all available methods
        $allmethods = $this->getAllShippingMethods($shipping, $insurance);
        $quotes = array('id' => $this->code,
                        'module' => $module,
                        'methods' => $this->getSelectedShippingMethod($allmethods, $method));
    }
    else  // build a list of all methods
    {
      $insuranceOption = $this->getInsuranceOption();

      // Sets $methods array
      if( $insuranceOption == '0' && $insurance == 0) // not offered
      {
        $methods = $this->buildShippingMethods('uninsured', 
                                               $shipping);
        $quotes = array('id' => $this->code,
                        'module' => $module,
                        'methods' => $methods);
      }
      else if( $insuranceOption == '2') // required
      {
        $methods = $this->buildShippingMethods('insured', 
                                               $shipping + $insurance);
        $quotes = array('id' => $this->code,
                                'module' => $module,
                                'methods' => $methods);
      }
      else if( $insuranceOption == '3') // included in S&H
      {
        $methods = $this->buildShippingMethods('insured', 
                                               $shipping);  // insurance included!
        $quotes = array('id' => $this->code,
                                'module' => $module,
                                'methods' => $methods);
      }
      else // default to OPTIONAL!
      {
          $method1 = $this->buildShippingMethods('insured', 
                                                 $shipping + $insurance);

          $method2 = $this->buildShippingMethods('uninsured', 
                                                 $shipping);

          $quotes = array('id' => $this->code,
                                  'module' => $module,
                                  'methods' => array_merge($method1, $method2));
      }


      if ($this->tax_class > 0)
      {
            $quotes['tax'] = tep_get_tax_rate($this->tax_class, $order->delivery['country']['id'], $order->delivery['zone_id']);
      }
    }

    if (tep_not_null($this->icon)) $quotes['icon'] = tep_image($this->icon, $this->title);
    return $quotes;
  }
  
  function buildShippingMethods($id, $cost)
  {
    // we want all of them to choose from
    $methods[] = array('id' => $id,
                       'title' => $this->methodTitles[$id],
                       'cost' => $cost);
                       
    if(//defined(MODULE_SHIPPING_FIXED_UPGRADE1_COST) &&
       doubleval(MODULE_SHIPPING_FIXED_UPGRADE1_COST) > 0.0)                       
    {
      $newid = $id . 'upgrade1';
      $methods[] = array('id' => $newid,
                         'title' => $this->methodTitles[$newid],
                         'cost' => $cost + doubleval(MODULE_SHIPPING_FIXED_UPGRADE1_COST));
    }
  
    if(//defined(MODULE_SHIPPING_FIXED_UPGRADE2_COST) &&
       doubleval(MODULE_SHIPPING_FIXED_UPGRADE2_COST) > 0.0)                       
    {
      $newid = $id . 'upgrade2';
      $methods[] = array('id' => $newid,
                         'title' => $this->methodTitles[$newid],
                         'cost' => $cost + doubleval(MODULE_SHIPPING_FIXED_UPGRADE2_COST));
    }

    if(//defined(MODULE_SHIPPING_FIXED_UPGRADE3_COST) &&
       doubleval(MODULE_SHIPPING_FIXED_UPGRADE3_COST) > 0.0)                       
    {
      $newid = $id . 'upgrade3';
      $methods[] = array('id' => $newid,
                         'title' => $this->methodTitles[$newid],
                         'cost' => $cost + doubleval(MODULE_SHIPPING_FIXED_UPGRADE3_COST));
    }
  
    return $methods;                            
  }
  
  function getAllShippingMethods($shipping, $insurance)
  {
    // build a list of all available methods
    $methods1 = $this->buildShippingMethods('insured', 
                                           $shipping + $insurance);
  
    $methods2 = $this->buildShippingMethods('uninsured', 
                                           $shipping);
                                               
    return array_merge($methods1, $methods2);
  }
  
  function getSelectedShippingMethod($allmethods, $method)
  {
    $selectedmethod = array();
    foreach($allmethods as $singlemethod)
    {
       if($singlemethod['id'] === $method)
          $selectedmethod[0] = $singlemethod;
    }
    
    return $selectedmethod;
  }
  
  function getAuctionProductsWithSpecifiedShipping()
  {
  	global $cart;
  	
  	$arrProducts = array();
	foreach($cart->internal_get_auction_products() as $key => $product) {
	  if ($product['shipping_type'] === 'F' ||
	      $product['shipping_type'] === 'N' ||
	      $product['shipping_type'] === 'E')
	  {
	    $arrProducts[] = $product;
	  }
	}
	
	return $arrProducts;  	
  }
  
  function getAuctionProductsWithCalculatedShipping()
  {
  	global $cart;
  	
  	$arrProducts = array();
	foreach($cart->internal_get_auction_products() as $key => $product) {
	  if ($product['shipping_type'] === 'C')
	  {
	    $arrProducts[] = $product;
	  }
	}
	
	return $arrProducts;  	
  }
  
  function getStoreProducts()
  {
  	global $cart;
  	
  	return $cart->internal_get_store_products();
  }


  function calculateShipping()
  {
    global $cart;

    $shipping = 0.0;
	if(MODULE_SHIPPING_FIXED_STATUS_EBAY === $this->FIXED_SHIPPING_SPECIFIED)
   		$shipping = $this->calculateShippingFromListing($this->getAuctionProductsWithSpecifiedShipping(), $shipping);
   	else
   		$shipping = $this->calculateShippingFromShippingTable($this->getAuctionProductsWithSpecifiedShipping(), $shipping);

    $arrProducts = array_merge($this->getAuctionProductsWithCalculatedShipping(), $this->getStoreProducts());   		
	$shipping = $this->calculateShippingFromShippingTable($arrProducts, $shipping);
    
    if($cart->count_contents() > 1 && is_numeric(MODULE_SHIPPING_FIXED_DISCOUNT))
    {
      $shipping = $shipping * ((100 - MODULE_SHIPPING_FIXED_DISCOUNT) / 100);
    }

    return $shipping;
  }

  function calculateShippingFromListing($arrProducts, $shipping)
  {
    reset($arrProducts);
    foreach ($arrProducts as $key => $item)
    {
      // Must be an auction item.  
      if($item['shipping_type'] === 'E')
      {
      	if(!isset($item['shipping']) || $item['shipping'] < 0)
      	{
          $this->addError($item['name']);
      	}
      	else
      	{
          // eBay handles shipping totals and accts for global vs. domestic
          $shipping += $item['shipping'];
      	}
      }
      else if($item['shipping_type'] === 'F' || $item['shipping_type'] === 'N')
      {
      	$temp = -1;
      	
        // we have to know whether global vs. domestic
        if( $order->delivery['country_id'] == STORE_COUNTRY )
        {
          $temp = $item['shipping'];
        }
        else
        {
          $temp = $item['shipping_global'];
        }
        
        if(!isset($temp) || $temp < 0)
        {
          $this->addError($item['name']);
        }
        else
        {
          $shipping += $temp;
        }
      }
    }
    return $shipping;
  }

  function calculateShippingFromShippingTable($arrProducts, $shipping)
  {
    global $cart, $order;

    reset($arrProducts);
    foreach ($arrProducts as $key => $item)
    {
      // This will remove any product attributes.  Our theory is
      // that attributes do not affect shipping price.
      $tokens = explode('{', $item['id']);
      $ids[] = $tokens[0];
    }

    if(is_array($ids) && sizeof($ids) > 0)
    {
      $shipping_query_raw = "SELECT pfs.*" .
                  " FROM " . TABLE_ABX_FIXED_SHIPPING . " pfs" .
                  " WHERE pfs.products_id in (" . implode(",", $ids) . ")" .
                  " ORDER BY pfs.shipping DESC";

      $shipping_query = tep_db_query($shipping_query_raw);
      
      // We have to do this in case the products in the cart share the
      // same products id (which is the case when we use a default eBay item
      // for all auction products)
      $arrOfShipping = array();
      while($shipping_query_array = tep_db_fetch_array($shipping_query))
      {
      	$id = $shipping_query_array['products_id'];
      	$arrOfShipping[$id] = $shipping_query_array;
      }
      
      $inloop = false;
      reset($arrProducts);
	  foreach ($arrProducts as $key => $item)
	  {
        $inloop = true;
        

        $tokens = explode('{',$item['id']);
        $id = $tokens[0];

        $shipping_query_array = $arrOfShipping[$id];
        
        $item_shipping = 0.0;
        $item_shipping_additional = 0.0;

        if($shipping_query_array['is_enabled'] !== '1')
        {
          // Fixed shipping not enabled for this product
          $this->addError($item['name']);
        }

        // Checks to see if the delivery address is domestic
        //   This avoid problems where they are global, but want it shipped domestic,
        //    or vice versa.
        if( $order->delivery['country_id'] == STORE_COUNTRY )
        {
          $item_shipping = $shipping_query_array['shipping'];
          $item_shipping_additional = $shipping_query_array['shipping_addl'];
        }
        else
        {
          $item_shipping = $shipping_query_array['shipping_global'];
          $item_shipping_additional = $shipping_query_array['shipping_global_addl'];
        }

        if($item_shipping < 0 || $item_shipping_additional < 0)
        {
          $this->addError($item['name']);
        }

        // Need to handle quantities when dealing with store items
        if ($shipping == 0.0)
        { $shipping += ($item_shipping + (($item['quantity'] - 1) * $item_shipping_additional)); }
        else
        { $shipping += ($item['quantity'] * $item_shipping_additional); }
      }
      
      if($inloop === false)
      {
        // No data returned FOR ANY ITEMS
        reset($arrProducts);
        foreach ($arrProducts as $key => $item)
        {
          $this->addError($item['name']);
        }        
      }      
    }
    return $shipping;
  }


  function calculateInsurance()
  {
	global $cart, $order;
	
	$insurance = 0.0;
	$subtotal = 0.0;
	
	foreach ($this->getAuctionProductsWithSpecifiedShipping() as $key => $item)
	{
	  if($item['insurance_option'] === '1' || $item['insurance_option'] === '2')
	  {
	  	 // optional or required insurance has been specified
	     $insurance += $item['insurance'];
	  }
      
      $subtotal += $item['quantity'] * $item['final_price'];
	}
	

	// Use calculated insurance for the remaining
	$total = 0.0;
	$arrProducts = array_merge($this->getAuctionProductsWithCalculatedShipping(), $this->getStoreProducts());
	foreach($arrProducts as $key => $item)
	{
	  $total += $item['quantity'] * $item['final_price'];
	}
	  
	$total -= $subtotal; 	
	
    if($total >= MODULE_SHIPPING_FIXED_COST_TO_INSURE_MINIMUM)
	    $insurance = MODULE_SHIPPING_FIXED_INSURANCE_BASE_AMT;
	
	// Don't want to double-charge if the minimum amt is 0
	if(MODULE_SHIPPING_FIXED_COST_TO_INSURE_MINIMUM < MODULE_SHIPPING_FIXED_COST_TO_INSURE_MULTIPLE)
	   $total -= MODULE_SHIPPING_FIXED_COST_TO_INSURE_MULTIPLE;
	else
	   $total -= MODULE_SHIPPING_FIXED_COST_TO_INSURE_MINIMUM;
	    
    if(intval(MODULE_SHIPPING_FIXED_COST_TO_INSURE_MULTIPLE) != 0)
    {
      $multiple = (int)($total / MODULE_SHIPPING_FIXED_COST_TO_INSURE_MULTIPLE);
      if ( $multiple > 0 )
      { $insurance += $multiple * MODULE_SHIPPING_FIXED_INSURANCE_MULTIPLE_AMT; }
    }

    return $insurance;
  }
  
  function containsStoreItems($products)
  {
    foreach ($products as $key => $item)
    {
      if(!isset($item['is_auction_item']))
      {
        return true;
      }
    }
  }

  function containsAuctionItems($products)
  {
    foreach ($products as $key => $item)
    {
      if(isset($item['is_auction_item']) && $item['is_auction_item'] = true)
      {
        return true;
      }
    }
  }

  function getInsuranceOption()
  {
    global $cart;
    foreach($cart->get_products() as $key => $item)
    {
      if(isset($item['insurance_option']))
      {
        return $item['insurance_option'];
      }
    }
    return "1"; // optional - default for store items
  }
  
  function addError($error)
  {
	if(!in_array($error, $this->errors))
	  $this->errors[] = $error;  	
  }
  
  function is_enabled_for_zone()
  {
 	global $order;
 	
    $check_flag = true;
	  if ((int)MODULE_SHIPPING_FIXED_ZONE > 0)  {
      $check_flag = false;
	    $check_query = tep_db_query("select zone_id from " . TABLE_ZONES_TO_GEO_ZONES . " where geo_zone_id = '" . MODULE_SHIPPING_FIXED_ZONE . "' and zone_country_id = '" . $order->delivery['country']['id'] . "' order by zone_id");
	    while ($check = tep_db_fetch_array($check_query)) {
	      if ($check['zone_id'] < 1) {
	        $check_flag = true;
	        break;
	      } elseif ($check['zone_id'] == $order->delivery['zone_id']) {
	        $check_flag = true;
	        break;
	      }
	    }
	  }  	
      return $check_flag;
  }
  
  function isCartEbaySpecifiedOnly()
  {
    global $cart;

    $shopItems = $cart->count_store_contents();
    if($shopItems > 0)
      return false;
 
	foreach($cart->get_products() as $key => $product) {
	  if (!isset($product['shipping_type']) || 
	      $product['shipping_type'] !== 'F' &&
	      $product['shipping_type'] !== 'N' &&
	      $product['shipping_type'] !== 'E')
	  {
	    return false;
	  }
	}
	  
	// All item use have shipping specified
    return true;
  }
  
  function isCartEbayCalculatedOnly()
  {
  	return !$this->isCartEbaySpecifiedOnly();
  }

  function isCartStoreOnly()
  {
  	  global $cart;
  	  
      $shopItems = $cart->count_store_contents();
      $auctionItems = $cart->count_auction_contents();
      
      if($shopItems > 0 && $auctionItems === 0)
        return true;
        
      return false;  	
  }
  
  function isCartStoreAndEbay()
  {
  	  global $cart;

      $shopItems = $cart->count_store_contents();
      $auctionItems = $cart->count_auction_contents();
      
      if($shopItems > 0 && $auctionItems > 0)
        return true;
        
      return false;  	
  }

  function is_enabled()
  {
    $cart = $GLOBALS['cart'];

    if($cart == null)	// only in the admin
         return false;

	  if(!$this->is_enabled_for_zone())
		 return false;

	  if($this->isCartEbaySpecifiedOnly() && MODULE_SHIPPING_FIXED_STATUS_EBAY === $this->OTHER_SHIPPING)
	  	 return false;		        

	  if($this->isCartEbayCalculatedOnly() && MODULE_SHIPPING_FIXED_STATUS_EBAY_CALC === $this->OTHER_SHIPPING)
	  	 return false;		        

	  if($this->isCartStoreOnly() && MODULE_SHIPPING_FIXED_STATUS_STORE === $this->OTHER_SHIPPING)
	  	 return false;		        

	  if($this->isCartStoreAndEbay() && MODULE_SHIPPING_FIXED_EBAY_WITH_STORE === $this->OTHER_SHIPPING)
	  	 return false;		        

   	  return true;
  }

    function check() {
      if (!isset($this->_check)) {
        $check_query = tep_db_query("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_SHIPPING_FIXED_STATUS_STORE'");
        $this->_check = tep_db_num_rows($check_query);
      }
      return $this->_check;
    }

    function install() {
    
      // add discount 
      // add enable fixed vs store shipping when store item are added to cart
    
     tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('eBay - Shipping Specified', 'MODULE_SHIPPING_FIXED_STATUS_EBAY', 'Shipping specified in listing', 'When the eBay order has shipping charges specified in the listing, calculate shipping using:', '6', '0', 'tep_cfg_select_option(array(\'Shipping specified in listing\', \'Fixed shipping table\', \'Other enabled shipping modules\'), ', now())");
     tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('eBay - Shipping Calculated', 'MODULE_SHIPPING_FIXED_STATUS_EBAY_CALC', 'Fixed shipping table', 'When the eBay order is marked as calculated during checkout, calculate shipping using:', '6', '0', 'tep_cfg_select_option(array(\'Fixed shipping table\', \'Other enabled shipping modules\'), ', now())");
     tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Shop Orders', 'MODULE_SHIPPING_FIXED_STATUS_STORE', 'Other enabled shipping modules', 'Calculate normal shopping cart items that contain no eBay orders using:', '6', '0', 'tep_cfg_select_option(array(\'Fixed shipping table\', \'Other enabled shipping modules\'), ', now())");
     tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('eBay+Shop Orders', 'MODULE_SHIPPING_FIXED_EBAY_WITH_STORE', 'Other enabled shipping modules', 'When additional shopping cart items are combined with eBay orders, calculate shipping using:', '6', '0', 'tep_cfg_select_option(array(\'Fixed shipping table\', \'Other enabled shipping modules\'), ', now())");
     tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Disable OTHER Shipping Modules', 'MODULE_SHIPPING_FIXED_DISABLE_OTHERS', 'True', 'Do you wish to disable all other shipping methods when Fixed Shipping is enabled?', '6', '0', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");
     tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, use_function, set_function, date_added) values ('Tax Class', 'MODULE_SHIPPING_FIXED_TAX_CLASS', '0', 'Use the following tax class on the shipping fee.', '6', '0', 'tep_get_tax_class_title', 'tep_cfg_pull_down_tax_classes(', now())");
     tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, use_function, set_function, date_added) values ('Shipping Zone', 'MODULE_SHIPPING_FIXED_ZONE', '0', 'If a zone is selected, only enable this shipping method for that zone.', '6', '0', 'tep_get_zone_class_title', 'tep_cfg_pull_down_zone_classes(', now())");
     tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Sort Order', 'MODULE_SHIPPING_FIXED_SORT_ORDER', '0', 'Sort order of display.', '6', '0', now())");

     tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Multiple Item Discount', 'MODULE_SHIPPING_FIXED_DISCOUNT', '0', 'Please enter the percentage discount that you offer to customers that purchase multiple items.<br>Ex: 20% = 20', '6', '0', now())");
     
     tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Cost Minimum', 'MODULE_SHIPPING_FIXED_COST_TO_INSURE_MINIMUM', '0', 'Minimum product cost for which insurance is charged.', '6', '0', now())");
     tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Cost Multiple', 'MODULE_SHIPPING_FIXED_COST_TO_INSURE_MULTIPLE', '50', 'Increment of product cost for which to charge additional insurance.', '6', '0', now())");
     tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Base Insurance', 'MODULE_SHIPPING_FIXED_INSURANCE_BASE_AMT', '2.20', 'Minimum insurance amount to charge.', '6', '0', now())");
     tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Addl Insurance', 'MODULE_SHIPPING_FIXED_INSURANCE_MULTIPLE_AMT', '1.30', 'Additional insurance amount to charge.', '6', '0', now())");


     tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Shipping Upgrade #1', 'MODULE_SHIPPING_FIXED_UPGRADE1_COST', '', 'Enter an amount if you wish to offer a shipping upgrade.', '6', '0', now())");
     tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Shipping Upgrade #2', 'MODULE_SHIPPING_FIXED_UPGRADE2_COST', '', 'Enter an amount if you wish to offer a shipping upgrade.', '6', '0', now())");
     tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Shipping Upgrade #3', 'MODULE_SHIPPING_FIXED_UPGRADE3_COST', '', 'Enter an amount if you wish to offer a shipping upgrade.', '6', '0', now())");
    }

    function remove() {
      tep_db_query("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->keys()) . "')");
    }

    function keys() {
      return array('MODULE_SHIPPING_FIXED_STATUS_EBAY', 'MODULE_SHIPPING_FIXED_STATUS_EBAY_CALC', 'MODULE_SHIPPING_FIXED_STATUS_STORE', 'MODULE_SHIPPING_FIXED_EBAY_WITH_STORE', 'MODULE_SHIPPING_FIXED_DISABLE_OTHERS', 'MODULE_SHIPPING_FIXED_TAX_CLASS', 'MODULE_SHIPPING_FIXED_ZONE', 'MODULE_SHIPPING_FIXED_SORT_ORDER', 'MODULE_SHIPPING_FIXED_DISCOUNT', 'MODULE_SHIPPING_FIXED_COST_TO_INSURE_MINIMUM', 'MODULE_SHIPPING_FIXED_COST_TO_INSURE_MULTIPLE', 'MODULE_SHIPPING_FIXED_INSURANCE_BASE_AMT', 'MODULE_SHIPPING_FIXED_INSURANCE_MULTIPLE_AMT', 'MODULE_SHIPPING_FIXED_UPGRADE1_COST', 'MODULE_SHIPPING_FIXED_UPGRADE2_COST', 'MODULE_SHIPPING_FIXED_UPGRADE3_COST');
    }
  }
?>